<Query Kind="Statements" />

// Deklaration af variabler
string Secret, Domain; List<Product> Products = new List<Product>();

/*** START ***/
// 1. Indsæt din hemmelige nøgle fra shoppens administration:
Secret = "07FnpNB9Qk8q";

// 2. Indsæt dit domæne:
Domain = "https://eksempel-shop.dk";

// 3. Hver linje herunder representerer et produkt. Dupliker linjerne for at tilføje flere produkter.
//    Opbygning: Products.Add(new Product(Varenummer, ID, Titel, Variant ID, Antal, Pris, Valuta, Vægt));
//    Bemærk: Valgfrie værdier, som ikke ønskes medtaget angives som "" og 0 ved tekst- og talværdier.
Products.Add(new Product("", 26, "Produkt 1 (tilbud ifølge aftale)", 0, 1, 26.79, "", 0));
Products.Add(new Product("", 8, "Produkt 2", 0, 1, 649.22, "", 0));
Products.Add(new Product("", 2, "Produkt 3 (variant)", 36, 1, 150, "", 0));

// 4. Tast F5 på dit tastatur eller klik på "play knappen" i topmenuen af LINQPad.
// Herefter køres koden og det genererede link vises i "Results" vinduet herunder.
/*** SLUT ***/

// Koden nedenfor håndterer det tekniske i opbygningen af kurvlinket
string productsJson = SerializeProducts(Products);
string secretPlusJson = Secret + productsJson;
string hash = System.Security.Cryptography.SHA1.Create().ComputeHash(Encoding.UTF8.GetBytes(secretPlusJson)).Aggregate(string.Empty, (x, y) => x + y.ToString("x2"));
// Combine URL with parameters and hash code
string url = Domain + "/actions/cart/addmulti/?input=" + productsJson + "&code=" + hash;
// Display output
("Genereret link:").Dump();
url.Dump();
("\n").Dump();
// Display object data
Products.Dump("Produktobjekter (program variabler og JSON data)");
// Helper method
static string SerializeProducts(List<Product> Products)
{
	string temp = string.Empty;
	if (Products.Count > 0)
	{
		temp = "[";
		for (int i = 0; i < Products.Count; i++)
		{
			temp += "{" + Products[i].GetValuesForUrl() + "}";
			if (i < Products.Count -1)
			{
				temp += ",";
			}
		}
		temp += "]";
	}
	return temp;
}
// Helper class
class Product
{
	public string sku, id, title, variant, amount, price, weight, currency;
	public Product(string Sku, int Id, string Title, int VariantId, int Amount, double Price, string Currency, double Weight)
	{
		sku = Sku;
		id = Convert.ToString(Id);
		title = Title;
		variant = Convert.ToString(VariantId);
		amount = Convert.ToString(Amount);
		price = Price.ToString("0.00", System.Globalization.CultureInfo.CreateSpecificCulture("en-US"));
		currency = Currency;
		weight = Weight.ToString("0.0", System.Globalization.CultureInfo.CreateSpecificCulture("en-US"));
	}

	public string Sku
	{
		get
		{
			if (!string.IsNullOrEmpty(sku))
			{
				return "\"sku\":" + "\"" + sku + "\""; // System.Web.HttpUtility.UrlEncode()
			}
			return string.Empty;
		}
	}
	public string Id
	{
		get
		{
			if (!string.IsNullOrEmpty(id) && id != "0")
			{
				return "\"product\":" + id;
			}
			return string.Empty;
		}
	}
	public string Title	{
		get
		{
			if (!string.IsNullOrEmpty(title))
			{
				return "\"title\":" + "\"" + title + "\""; // System.Web.HttpUtility.UrlEncode()
			}
			return string.Empty;
		}
	}
	public string VariantId
	{
		get
		{
			if (!string.IsNullOrEmpty(variant) && variant != "0")
			{
				return "\"variant\":" + variant;
			}
			return string.Empty;
		}
	}
	public string Amount
	{
		get
		{
			if (!string.IsNullOrEmpty(amount))
			{
				return "\"amount\":" + amount;
			}
			return string.Empty;
		}
	}
	public string Price
	{
		get
		{
			if (!string.IsNullOrEmpty(price) && price != "0.00")
			{
				return "\"price\":" + price;
			}
			return string.Empty;
		}
	}
	public string Currency
	{
		get
		{
			if (!string.IsNullOrEmpty(currency))
			{
				return "\"currency\":" + "\"" + currency + "\"";
			}
			return string.Empty;
		}
	}
	public string Weight
	{
		get
		{
			if (!string.IsNullOrEmpty(weight) && weight != "0.0")
			{
				return "\"weight\":" + weight;
			}
			return string.Empty;
		}
	}

	public string GetValuesForUrl()
	{
		string temp = Util(Sku) + Util(Id) + Util(Title) + Util(VariantId) + Util(Amount) + Util(Price) + Util(Currency) + Util(Weight);
		if (!string.IsNullOrEmpty(temp) && temp[temp.Length - 1] == ',') // Remove the last comma
		{
			temp = temp.Substring(0, temp.Length -1);
		}
	  	return temp;
	}

	private string Util(string input)
	{
		if (!string.IsNullOrEmpty(input))
		{
			return input + ",";
		}
		return string.Empty;
	}
}